#include <stdio.h>

#ifdef sun
#ifdef _IOSTRG
#define sunos
#else
#define solaris
#endif
#endif

#include <ar.h>
#ifdef AIAMAG
#define aix
#endif

/*
 * Select system dependent system calls about:
 *   synchronous I/O multiplexing: {HAS_SELECT, HAS_POLL}
 *   terminal control: {USE_SGTTY,  USE_TERMIO, USE_TERMIOS}
 */

#if	   defined(sunos) \
	|| defined(ultrix)\
	|| defined(sony_news)
#define USE_SGTTY
#define HAS_SELECT
#endif

#if	   defined(solaris) \
	|| defined(aix)\
	|| defined(__linux__)

#define USE_TERMIO
#define HAS_POLL
#endif

#if defined(hpux)
#define USE_TERMIO
#define HAS_SELECT
#endif

/*
 * Get the count of bufferd characters.
 */
#ifdef __linux__
#define READYCC(fp)	(fp->_egptr - fp->_gptr)
#else
#define READYCC(fp)	(fp->_cnt)
#endif
